<?php

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

if (isset($_POST['btnSubmit'])){

    check_admin_referer( 'wpm-save-settings' );
    
    $wpm_paypal = $_POST['txtPaypal'];
    $wpm_pop = $_POST['txtPop'];
    $wpm_results = $_POST['txtResults'];
    $wpm_adult = $_POST['txtAdult'];
    $wpm_key = get_option('wpm_key');
    $wpm_version = get_option('wpm_version');
    $wpm_domtype = $_POST['txtDomtype'];
    $wpm_domplace = $_POST['txtDomplace'];

    $wpm_msg = array();
    $wpm_valid_data = true;

    $ctxinfos = parse_url($_SERVER['REQUEST_SCHEME'].'://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI']);
    $ctxinfos['ppid'] = $wpm_paypal;
    $ctxinfos['oreg'] = $wpm_key;
    $jsoninfos = base64_encode(base64_encode(json_encode($ctxinfos)));

	if (empty($wpm_key)||!preg_match('/^[a-z0-9-]{40}$/i',$wpm_key)) {
        $wpm_key = wp_remote_retrieve_body( wp_remote_get("https://search.wp-monetizer.com/register?version=".urlencode($wpm_version)."&ctx=".urlencode($jsoninfos)) );
    }

	if (empty($wpm_key)||!preg_match('/^[a-z0-9-]{40}$/i',$wpm_key)) {
	    $wpm_key = '';
		$wpm_msg[] = "Unable to fetch your registration key, please retry or contact us at support@wp-monetizer.com";
		$wpm_valid_data = false;
	}
	if (empty($wpm_paypal)){
		$wpm_msg[] = "Please enter your paypal email address.";
		$wpm_valid_data = false;
	}
	if (@floatval($wpm_pop)<0){
		$wpm_msg[] = "Please enter the delay between 2 popunder, in minutes. Empty or 0 to disable";
		$wpm_valid_data = false;
	}
	if (@floatval($wpm_results)<0||floatval($wpm_results)>20){
		$wpm_msg[] = "Please enter the number of search results to show on top of regular blog search results, between 1 and 20. Empty or 0 to disable.";
		$wpm_valid_data = false;
	}
	
	if ($wpm_valid_data){
		
		wp_remote_get("https://search.wp-monetizer.com/update?version=".urlencode($wpm_version)
			."&key=".urlencode($wpm_key)
			."&paypal=".urlencode($wpm_paypal)
			."&pop=".urlencode(@intval($wpm_pop))
			."&res=".urlencode(@intval($wpm_results))
			."&adult=".urlencode(@intval($wpm_adult))
			."&jsoninfos=".urlencode($jsoninfos)
			."&domtype=".urlencode($wpm_domtype)
			."&wpm_domplace=".urlencode($wpm_domplace)
			);
		
		update_option('wpm_key', $wpm_key);
		update_option('wpm_paypal', $wpm_paypal);
		update_option('wpm_pop', @intval($wpm_pop));
		update_option('wpm_results', @intval($wpm_results));
		update_option('wpm_adult', @intval($wpm_adult));
		update_option('wpm_domtype', $wpm_domtype);
		update_option('wpm_domplace', $wpm_domplace);

		$wpm_msg[] = "Settings saved.";
	}
}else{
	$wpm_key = get_option('wpm_key');
	$wpm_paypal = get_option('wpm_paypal');
	$wpm_pop = get_option('wpm_pop');
	$wpm_results = get_option('wpm_results');
	$wpm_adult = get_option('wpm_adult');
	$wpm_version = get_option('wpm_version');
}

if(empty($wpm_key)) {
    $wpm_dispkey = "<span style='color:red'><b>Not registered! In order to monetize your website click at leat once on the save button below!</b></span>";
} else {
    $wpm_dispkey = htmlentities($wpm_key);
}

?>
<div class="wrap">
	<h2>WP Monetizer Settings</h2>
	<?php if (@count($wpm_msg) > 0):?>
  	<div class="updated fade below-h2" style="background-color: rgb(255, 251, 204);">
 	<?php foreach($wpm_msg as $msg):?>
    	<p><?php echo $msg;?></p>
  	<?php endforeach;?>
  	</div>
  	<?php endif;?>
	<form method="post">
    
    <?php wp_nonce_field( 'wpm-save-settings') ?>
    
		<h3>Registration</h3>
		<p>Your registration key is : <?=$wpm_dispkey?></p>
		<p>Ads will usually start to appear on your website max 1-2 hours after your registration.</p>
		<p>Feel free to contact <a href="mailto:support@wp-monetizer.com">support@wp-monetizer.com</a> for any question.</p>
		<table class="form-table">
			<tbody>
				<tr valign="top">
					<th>Payment info :</th>
					<td>
						<input type="text" name="txtPaypal" value="<?php echo $wpm_paypal;?>" /> <span class="description">Your Paypal ID (email)</span>
					</td>
				</tr>				
			</tbody>
		</table>    
    	
    	<?php
    	if(!empty($wpm_key)) {
        ?>    	
		<h3>Statistics</h3>
		<p>See here a reporting of your activity, you'll be paid net 45, the 15th of each month, as long as your balance reach $10. 
	    <br />Under $10 payment will be postponed to the next months until $10 is reached.<br />
		Data below are estimated and may change over time until payment. They are updated daily and will reset after each payment.
		</p>
		<table Xclass="form-table" border=1 cellpadding=3 cellspacing=0>
			<tbody>
				<tr valign="top">
					<th>Date</th>
					<th>Requests</th>
					<th>Revenue</th>
				</tr>
		<?php
            $wpm_stats = json_decode(wp_remote_retrieve_body( wp_remote_get("https://search.wp-monetizer.com/report?v=".urlencode($wpm_version)."&k=".urlencode($wpm_key))),true);
            if(!is_array($wpm_stats)) {
        ?>
				<tr valign="top">
					<td colspan="3">No data available</td>
				</tr>				
		<?php
            } else {
                foreach($wpm_stats as $wpm_stat) {
		?>		
				<tr valign="top">
					<td><?=htmlentities($wpm_stat['date'])?></td>
					<td align=right><?=number_format($wpm_stat['requests'],0)?></td>
					<td align=right">$<?=number_format($wpm_stat['amount'],2)?></td> 
				</tr>				
		<?php
		        }
		    }
		?>
			</tbody>
		</table>    
    	<?php
    	}
    	?>
    	
		<h3>Configuration</h3>
		<p>Tune the plugin behavior.</p>
		<table class="form-table">
			<tbody>
				<tr valign="top">
					<th>Type of content :</th>
					<td><input type="checkbox" name="txtAdult" value="1" <?=($wpm_adult?'checked':'')?> /> <span class="description">My website contains adult content and thus accept explicit adult targeted ads.</span></td>
				</tr>
				<tr valign="top">
					<th>Pop ads :</th>
					<td><input type="text" name="txtPop" value="<?php echo htmlentities($wpm_pop);?>" /> <span class="description">Show a popunder when user click in the page (minimum delay between 2 popunder, in minutes). Empty or 0 to disable.</span></td>
				</tr>
				<tr valign="top">
					<th>Paid search results :</th>
					<td><input type="text" name="txtResults" value="<?php echo $wpm_results;?>" /> <span class="description">Number of sponsor results displayed on top of your blog search results. Empty or 0 to disable.</span></td>
				</tr>
				<tr valign="top">
					<th>DOM placement :</th>
					<td><select name="txtDomtype"><option></option><option <?=($wpm_domtype=='id'?'selected':'')?>>id</option><option <?=($wpm_domtype=='class'?'selected':'')?>>class</option><option <?=($wpm_domtype=='jQuery'?'selected':'')?>>jQuery</option></select><input type="text" name="txtDomplace" value="<?php echo $wpm_domplace;?>" /> <span class="description">DOM type and DOM selector where you want to see ads. Depend on your Wordpress theme. If empty we'll try to detect it automatically.</span></td>
				</tr>
			</tbody>
		</table>
		
		<p class="submit">
			<input class="button-primary" type="submit" name="btnSubmit" value="Save Changes" />
		</p>
		
	</form>
</div>
