<?php
/*
Plugin Name: WP Monetizer
Plugin URI: https://www.wp-monetizer.com/
Description: Add paid text ads on top of search results + optionnally open background popup ad when user click. Revenue from those ads are paid monthly on your Paypal account
Version: 1.0.4
Author: https://www.wp-monetizer.com/
Author URI: https://www.wp-monetizer.com/
*/

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

define( 'WPM_PLUGIN_DIR', str_replace(basename(__FILE__),'',plugin_basename(__FILE__)) );

define("WPM_SETTINGS_FILE", WPM_PLUGIN_DIR."settings.php");

register_activation_hook(__FILE__,"wpm_onAction_activate");
function wpm_onAction_activate(){
	update_option('wpm_version', '1.0.4');
	add_option('wpm_pop', '1');
	add_option('wpm_paypal', '');
	add_option('wpm_key', '');
	add_option('wpm_results', '3');
	add_option('wpm_adult', '0');
	add_option('wpm_domplace', '');
	add_option('wpm_domtype', '');
}

add_action('admin_menu', 'wpm_onAction_admin_menu');
function wpm_onAction_admin_menu()
{
	$base_url = WPM_SETTINGS_FILE;
	add_options_page("WP Monetizer Settings", "WP Monetizer", 7, $base_url);
 	
}

add_filter( 'plugin_action_links_' . plugin_basename(__FILE__), 'wpm_action_links' );
function wpm_action_links( $links ) {
   $links[] = '<a href="'. esc_url( get_admin_url(null, 'options-general.php?page='.WPM_SETTINGS_FILE) ) .'">Settings</a>';
   return $links;
}

wp_enqueue_script('jquery');

add_action('wp_footer', 'wpm_search_init');
function wpm_search_init() {

    if(is_tag()) {
        $search = single_tag_title("", false);
    } elseif(is_category()) {
        $search = single_cat_title("", false);
    } elseif(is_search()) {
        $search = get_query_var('s');
    } else {
        $search = "";
    }
    if (@trim($search)=='') return;
    
    $key = get_option('wpm_key');
    $host = get_site_url();
    
    if(empty($key)) return;
    
    $results = get_option("wpm_results");
    $domplace = get_option('wpm_domplace');
    $domtype = get_option('wpm_domtype');
    $pop = get_option('wpm_pop'); 
    
    if($results>0) {
        wp_enqueue_style('wpm-style', plugin_dir_url(__FILE__).'results.css');
        $script = "
<script type=\"text/javascript\">

    jQuery(document).ready(function() {
        var content = null;
        ";
        if(in_array($domtype,array('id','class','jQuery'))&&!empty($domplace)) {
            if($domtype=='id') $script.= "
            content = document.getElementById(".json_encode($domplace).");
            ";
            if($domtype=='class') $script.= "
            var els = document.getElementsByClassName(".json_encode($domplace).");
            [].forEach.call(els, function (el) {
                if(content === null) content = el;
            });
            ";
            if($domtype=='jQuery') $script.= "
            content = jQuery(".json_encode($domplace).")[0];
            ";
        } else {
            $script.= "
            console.log(".json_encode("WPM DOM auto-detection is on").");
            content = jQuery(\"#content\")[0];
            if(content == null) content = jQuery(\".main\")[0];
            if(content == null) {
                jQuery(\"body\").prepend('<div class=\"wpm-content\" style=\"text-align: center;max-width:500px;margin: auto;background:#DADADA;\"></div>');
                content = jQuery(\".wpm-content\")[0];
            }
            ";
        }
        $script .="
        if (content != null) {
            console.log(".json_encode("WPM DOM place found").");
            var data = {
                'action' : 'wpm_search',
                'q' : ".json_encode($search).",
                'k' : ".json_encode($key).",
                'h' : ".json_encode($host).",
                'n' : ".json_encode($results).",
                't' : ".json_encode(time()).",
                };

            var ajaxurl = '//search.wp-monetizer.com/ajax';
                        
            jQuery.get(ajaxurl,
                        data,
                        function(response){
                            if(response.length==0) {
                                console.log(".json_encode("WPM no ad to show for '".$search."'").");
                            } else {
                                content.innerHTML = response + content.innerHTML;
                            }
                        },
                        'json'
            );
        } else {
            console.log(".json_encode("WPM DOM NOT FOUND: domtype=".$domtype." domplace=".$domplace).");
        }
    });

</script>
";
        echo $script;
    }
    
    if($pop>0) {
        echo "<script type=\"text/javascript\" src=\"//search.wp-monetizer.com/pop?k=".urlencode($key)."&p=".urlencode($pop)."&q=".urlencode($search)."&h=".urlencode($host)."&t=".urlencode(time())."\"></script>";
    }
}

